# WELCOME TO THE README PAGE of # IRIS

Iris is a smart machine that interacts with you via audio, camera and visual effects. It aims to be installed in a workplace environment. Iris has 3 characters: guru, pirate and announcer. The files follow this nomination.


## THE FILES

* The .json files (“guru.json”, “rebel.json” and “announcer.json”) are the files where all the sentences the characters say are stored.
* The script “guru-pirate.py” is the script that combines content of guru and pirate (from json files) to play their messages. It also integrates LEDs when the characters speak. When characters speak the LEDs light up and perform effects. This script runs when the camera detects motion.
* The script "motion_detector_2.py" is used to detect motion from camera connected to raspberry pi.
* The script "announcements.py" plays the messages of the Announcer (from json file)
* The credits for this project are under the script “colophon.py”, they are read out loud with espeak when covering the camera with a finger for a few seconds.
* “Motion.sh” is the script from where you bring everything to life. Just run ./motion.sh on your terminal.



## INSTALL DEPENDENCIES

 * 2018-12-12
 * Performed in linux Debian
 * Raspberry Pi 3 B+
 * Pi Camera v2.1
 * LEDs — WS2801B RGB LED Streifen Farbeffekte

— Install Pip 
	sudo apt-get update
	sudo apt-get install python-pip

— Check python2 version
	python --version

— Check pip version 
	pip --version

— Properly install Setuptools module 
	sudo apt-get install python-dev python-setuptools

— Install opencv dependencies with pip 
	sudo pip install opencv-python

— Install imutils dependencies with pip 
	sudo pip install imutils

— Install Pillow dependencies with pip 
	sudo pip install Pillow

— Install espeak (to play the pirate) 
	sudo apt-get install espeak

— Install aplay (to play the colophon) 
	sudo apt-get install aplay

— Install sox (to play the colophon) 
	sudo apt-get install sox

## RUN THE PROGRAM ON RASPBERRY PI AT STARTUP
Tutorial on how to run a program on your Raspberry Pi at startup:
https://www.dexterindustries.com/howto/run-a-program-on-your-raspberry-pi-at-startup/

The fourth method to run a program on your Raspberry Pi at startup is to use the systemd files. systemd provides a standard process for controlling what programs run when a Linux system boots up. Note that systemd is available only from the Jessie versions of Raspbian OS.

— Step 1: Create A Unit File
	Open a sample unit file using the command as shown below:
			sudo nano /lib/systemd/system/sample.service
	Add in the following text:
			[Unit]
			Description=My Sample Service
			After=multi-user.target

			[Service]
			Type=idle
			ExecStart=/usr/bin/python /home/pi/sample.py

			[Install]
			WantedBy=multi-user.target

You should save and exit the nano editor.
This defines a new service called “Sample Service” and we are requesting that it is launched once the multi-user environment is available. The “ExecStart” parameter is used to specify the command we want to run. The “Type” is set to “idle” to ensure that the ExecStart command is run only when everything else has loaded. Note that the paths are absolute and define the complete location of Python as well as the location of our Python script.

In order to store the script’s text output in a log file you can change the ExecStart line to:
			ExecStart=/usr/bin/python /home/pi/sample.py > /home/pi/sample.log 2>&1
The permission on the unit file needs to be set to 644:
			sudo chmod 644 /lib/systemd/system/sample.service


— Step 2: Configure systemd
Now the unit file has been defined we can tell systemd to start it during the boot sequence:
		sudo systemctl daemon-reload
		sudo systemctl enable sample.service
Reboot the Pi and your custom service should run:
		sudo reboot

## LOCATION
* scripts locations /var/www/html/lifeHackAgent
* audio recording script /var/www/html/lifeHackAgent/Audio_recordings

## TEST SYSTEM:
* `./motion.sh`

## CRONJOB:
runs announcements.py


## systemd service file
* run on boot
* location: /lib/systemd/system/lifehack.service
* status: sudo systemctl ststatus lifehack.service
* start: sudo systemctl start lifehack.service
* stop: sudo systemctl stop lifehack.service


################################################################################################

Iris Version 0.5 Contributors: Gill Baldwin, Simon Browne, Tancredi Di Giovanni, Paloma García, Rita Graça, Artemis Gryllaki, Pedro Sá Couto, Biyi Wen, Bohye Woo, Silvio Lorusso, Aymeric Mansoux, André Castro, Steve Rushton, Michael Murtaugh, Leslie Robbins. Produced and published by the Experimental Publishing (XPUB) program of the Piet Zwart Institute, Rotterdam, December 2018. A collaboration between the Research Department of Het Nieuwe Instituut and XPUB.

You can find IRIS launching:https://burnout.hetnieuweinstituut.nl/en/activities/life-hacks-introducing-iris

################################################################################################
